package com.zillion.database.util;

import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.security.UserGroupInformation;
import org.zillion.util.log.LogUtil;

public class KerberosUtil {

	public static void reloginFromKeytab(IDatabase DatabaseImpl) {
		DatabaseImpl_HBase impl = null;
		if (DatabaseImpl instanceof DatabaseImpl_HBase) {
			impl = (DatabaseImpl_HBase) DatabaseImpl;
		} else if (DatabaseImpl instanceof DatabaseImpl_Mix) {
			impl = ((DatabaseImpl_Mix) DatabaseImpl).hbase;
		}
		if (impl != null) {
			Configuration configuration = impl.configuration;
			String principal = configuration.get("kerberos.principal");
			String file = configuration.get("keytab.file");
			if (principal != null && file != null) {
				// try {
				// UserGroupInformation.getLoginUser().checkTGTAndReloginFromKeytab();
				// } catch (IOException e) {
				// LogUtil.error(LogUtil.GetExceptionStackTrace(e));
				// }
				try {
					UserGroupInformation.getLoginUser().reloginFromKeytab();
				} catch (IOException e) {
					LogUtil.error(LogUtil.GetExceptionStackTrace(e));
				}
			}
		}
	}
}
